import { defineComponent as X, computed as y, openBlock as l, createElementBlock as o, normalizeClass as U, createBlock as k, createSlots as Y, withCtx as f, createTextVNode as B, toDisplayString as i, createCommentVNode as a, createVNode as p, unref as n, createElementVNode as u, Fragment as c, renderList as h } from "vue";
import { Disclosure as ee, DisclosurePanel as te, DisclosureButton as le } from "@headlessui/vue";
import { ScalarMarkdown as S, ScalarIcon as se } from "@scalar/components";
import { formatExample as oe } from "./helpers/formatExample.js";
import { optimizeValueForDisplay as re, discriminators as Z } from "./helpers/optimizeValueForDisplay.js";
import M from "./Schema.vue.js";
import $ from "./SchemaDiscriminator.vue.js";
import ne from "./SchemaPropertyHeading.vue.js";
const ae = {
  key: 1,
  class: "property-description"
}, ie = {
  key: 2,
  class: "property-description"
}, pe = {
  key: 3,
  class: "property-example custom-scroll"
}, me = { class: "property-example-value" }, ce = {
  key: 4,
  class: "property-example custom-scroll"
}, de = { class: "property-example-label" }, ue = {
  key: 5,
  class: "property-enum"
}, ye = {
  key: 0,
  class: "property-list"
}, fe = { class: "property-heading" }, he = { class: "property-name" }, ve = { class: "property-description" }, ge = {
  key: 1,
  class: "property-enum-values"
}, be = {
  key: 6,
  class: "children"
}, ke = {
  key: 0,
  class: "children"
}, Pe = /* @__PURE__ */ X({
  __name: "SchemaProperty",
  props: {
    value: {},
    level: { default: 0 },
    name: {},
    required: { type: Boolean, default: !1 },
    compact: { type: Boolean, default: !1 },
    description: {},
    additional: { type: Boolean },
    pattern: { type: Boolean },
    withExamples: { type: Boolean, default: !0 },
    schemas: {},
    hideHeading: { type: Boolean }
  },
  setup(G) {
    const J = G, j = {
      integer: {
        _default: "Integer numbers.",
        int32: "Signed 32-bit integers (commonly used integer type).",
        int64: "Signed 64-bit integers (long type)."
      },
      string: {
        date: "full-date notation as defined by RFC 3339, section 5.6, for example, 2017-07-21",
        "date-time": "the date-time notation as defined by RFC 3339, section 5.6, for example, 2017-07-21T17:32:28Z",
        password: "a hint to UIs to mask the input",
        byte: "base64-encoded characters, for example, U3dhZ2dlciByb2Nrcw==",
        binary: "binary data, used to describe files"
      }
    }, E = (e, s) => s != null && s.properties || s != null && s.additionalProperties || s != null && s.patternProperties || s != null && s.allOf ? null : e || (s == null ? void 0 : s.description) || null, D = (e) => !e || !j[e.type] ? null : j[e.type][e.format || "_default"], d = (e) => {
      var s;
      return (e == null ? void 0 : e.enum) || ((s = e == null ? void 0 : e.items) == null ? void 0 : s.enum) || [];
    }, H = y(
      () => d(t.value).length > 9
    ), _ = y(() => H.value ? 5 : 9), K = y(
      () => d(t.value).slice(0, _.value)
    ), Q = y(
      () => d(t.value).slice(_.value)
    ), t = y(() => re(J.value)), w = Z.find((e) => !t.value || typeof t.value != "object" ? !1 : e in t.value || t.value.items && typeof t.value.items == "object" && e in t.value.items), W = (e, s, v, g, b) => s || v || g || (e == null ? void 0 : e.deprecated) || (e == null ? void 0 : e.const) || (e == null ? void 0 : e.enum) && e.enum.length === 1 || (e == null ? void 0 : e.type) || (e == null ? void 0 : e.nullable) === !0 || (e == null ? void 0 : e.writeOnly) || (e == null ? void 0 : e.readOnly) || b;
    return (e, s) => {
      var v, g, b, P, C, q, x, A, F, N, O, V, z, I, L, T;
      return l(), o("li", {
        class: U(["property", [
          (E(e.description, t.value), ""),
          `property--level-${e.level}`,
          {
            "property--compact": e.compact,
            "property--deprecated": (v = t.value) == null ? void 0 : v.deprecated
          }
        ]])
      }, [
        W(
          t.value,
          e.name,
          e.additional,
          e.pattern,
          e.required
        ) ? (l(), k(ne, {
          key: 0,
          additional: e.additional,
          enum: d(t.value).length > 0,
          pattern: e.pattern,
          required: e.required,
          value: t.value
        }, Y({ _: 2 }, [
          e.name ? {
            name: "name",
            fn: f(() => [
              B(i(e.name), 1)
            ]),
            key: "0"
          } : void 0,
          (g = t.value) != null && g.example ? {
            name: "example",
            fn: f(() => [
              B(" Example: " + i(t.value.example), 1)
            ]),
            key: "1"
          } : void 0
        ]), 1032, ["additional", "enum", "pattern", "required", "value"])) : a("", !0),
        E(e.description, t.value) ? (l(), o("div", ae, [
          p(n(S), {
            value: E(e.description, t.value)
          }, null, 8, ["value"])
        ])) : D(t.value) ? (l(), o("div", ie, [
          p(n(S), {
            value: D(t.value) || ""
          }, null, 8, ["value"])
        ])) : a("", !0),
        e.withExamples && ((b = t.value) != null && b.example || (C = (P = t.value) == null ? void 0 : P.items) != null && C.example) ? (l(), o("div", pe, [
          s[0] || (s[0] = u("span", { class: "property-example-label" }, "Example", -1)),
          u("code", me, i(n(oe)(
            ((q = t.value) == null ? void 0 : q.example) || n(w) && ((x = t.value) == null ? void 0 : x.items) && typeof t.value.items == "object" && t.value.items[n(w)]
          )), 1)
        ])) : a("", !0),
        (A = t.value) != null && A.examples && typeof t.value.examples == "object" && Object.keys(t.value.examples).length > 0 ? (l(), o("div", ce, [
          u("span", de, i(Object.keys(t.value.examples).length === 1 ? "Example" : "Examples"), 1),
          (l(!0), o(c, null, h(t.value.examples, (r, m) => (l(), o("code", {
            key: m,
            class: "property-example-value"
          }, i(r), 1))), 128))
        ])) : a("", !0),
        ((F = d(t.value)) == null ? void 0 : F.length) > 0 ? (l(), o("div", ue, [
          Array.isArray((N = t.value) == null ? void 0 : N["x-enumDescriptions"]) ? (l(), o("div", ye, [
            (l(!0), o(c, null, h(d(t.value), (r) => (l(), o("div", {
              key: r,
              class: "property"
            }, [
              u("div", fe, [
                u("div", he, i(r), 1)
              ]),
              u("div", ve, [
                p(n(S), {
                  value: t.value["x-enumDescriptions"][r]
                }, null, 8, ["value"])
              ])
            ]))), 128))
          ])) : (l(), o("ul", ge, [
            (l(!0), o(c, null, h(K.value, (r) => (l(), o("li", {
              key: r,
              class: "property-enum-value"
            }, i(r), 1))), 128)),
            H.value ? (l(), k(n(ee), { key: 0 }, {
              default: f(({ open: r }) => [
                p(n(te), null, {
                  default: f(() => [
                    (l(!0), o(c, null, h(Q.value, (m) => (l(), o("li", {
                      key: m,
                      class: "property-enum-value"
                    }, i(m), 1))), 128))
                  ]),
                  _: 1
                }),
                p(n(le), { class: "enum-toggle-button" }, {
                  default: f(() => [
                    p(n(se), {
                      class: U(["enum-toggle-button-icon", { "enum-toggle-button-icon--open": r }]),
                      icon: "Add",
                      size: "sm"
                    }, null, 8, ["class"]),
                    B(" " + i(r ? "Hide values" : "Show all values"), 1)
                  ]),
                  _: 2
                }, 1024)
              ]),
              _: 1
            })) : a("", !0)
          ]))
        ])) : a("", !0),
        ((O = t.value) == null ? void 0 : O.type) === "object" && ((V = t.value) != null && V.properties || (z = t.value) != null && z.additionalProperties) ? (l(), o("div", be, [
          p(M, {
            compact: e.compact,
            level: e.level + 1,
            value: t.value
          }, null, 8, ["compact", "level", "value"])
        ])) : a("", !0),
        (I = t.value) != null && I.items && typeof t.value.items == "object" && "type" in t.value.items && typeof t.value.items.type == "string" ? (l(), o(c, { key: 7 }, [
          ["object"].includes((T = (L = t.value) == null ? void 0 : L.items) == null ? void 0 : T.type) ? (l(), o("div", ke, [
            p(M, {
              compact: e.compact,
              level: e.level + 1,
              value: t.value.items
            }, null, 8, ["compact", "level", "value"])
          ])) : a("", !0)
        ], 64)) : a("", !0),
        (l(!0), o(c, null, h(n(Z), (r) => {
          var m, R;
          return l(), o(c, { key: r }, [
            (m = t.value) != null && m[r] ? (l(), k($, {
              key: 0,
              compact: e.compact,
              discriminator: r,
              hideHeading: e.hideHeading,
              level: e.level,
              schemas: e.schemas,
              value: t.value
            }, null, 8, ["compact", "discriminator", "hideHeading", "level", "schemas", "value"])) : (R = t.value) != null && R.items && typeof r == "string" && typeof t.value.items == "object" && r in t.value.items && Array.isArray(t.value.items[r]) && e.level < 3 ? (l(), k($, {
              key: 1,
              compact: e.compact,
              discriminator: r,
              hideHeading: e.hideHeading,
              level: e.level,
              schemas: e.schemas,
              value: t.value.items
            }, null, 8, ["compact", "discriminator", "hideHeading", "level", "schemas", "value"])) : a("", !0)
          ], 64);
        }), 128))
      ], 2);
    };
  }
});
export {
  Pe as default
};
