import { defineComponent as Y, toRef as A, ref as W, watch as y, computed as _, openBlock as f, createBlock as B, unref as n, withCtx as i, createElementVNode as a, createVNode as g, isRef as j, withKeys as v, withModifiers as b, createTextVNode as d, toDisplayString as u, createElementBlock as N, Fragment as x, renderList as G, createSlots as J, normalizeClass as Q, createCommentVNode as X } from "vue";
import { ScalarModal as Z, ScalarSearchInput as ee, ScalarSearchResultList as te, ScalarSearchResultItem as oe } from "@scalar/components";
import { nanoid as se } from "nanoid";
import { lazyBus as ae } from "../../components/Content/Lazy/lazyBus.js";
import ne from "../../components/Sidebar/SidebarHttpBadge.vue.js";
import { useSearchIndex as re } from "./useSearchIndex.js";
import { useSidebar as le } from "../../hooks/useSidebar.js";
import { scrollToId as E } from "../../helpers/scrollToId.js";
const ie = { class: "sr-only" }, ce = { class: "sr-only" }, ve = /* @__PURE__ */ Y({
  __name: "SearchModal",
  props: {
    parsedSpec: {},
    modalState: {}
  },
  setup(L) {
    const m = L, F = A(m, "parsedSpec"), S = se(), R = `${S}-search-result`, w = `${S}-search-instructions`, I = (o) => `${S}${o}`, {
      resetSearch: P,
      fuseSearch: q,
      selectedSearchResult: l,
      searchResultsWithPlaceholderResults: c,
      searchText: p
    } = re({
      specification: F
    }), D = {
      heading: "DocsPage",
      model: "Brackets",
      req: "Terminal",
      tag: "CodeFolder",
      webhook: "Terminal"
    }, $ = {
      heading: "Document Heading",
      req: "Request",
      tag: "Tag",
      model: "",
      // The title of the entry is already "Model"
      webhook: ""
      // The title of the entry is already "Webhook"
    }, M = W(null);
    y(
      () => m.modalState.open,
      (o) => {
        o && P();
      }
    );
    const { setCollapsedSidebarItem: H } = le(), U = /#(tag\/[^/]*)/;
    function k(o) {
      let t = "models";
      const e = o.item.href.match(U);
      e != null && e.length && e.length > 1 && (t = e[1]), H(t, !0);
      const s = o.item.href.replace("#", "");
      if (document.getElementById(s))
        E(s), m.modalState.hide();
      else {
        const r = ae.on((h) => {
          h.id === s && (E(s), r(), m.modalState.hide());
        });
      }
    }
    y(l, (o) => {
      var s;
      const t = c.value[o], e = I(t == null ? void 0 : t.item.href);
      (s = document.getElementById(e)) == null || s.scrollIntoView({
        behavior: "smooth",
        block: "nearest"
      });
    });
    const K = _(() => {
      const o = c.value;
      if (!o.length)
        return "No results found";
      const t = o[l.value].item, e = p.value.length ? `${o.length} result${o.length === 1 ? "" : "s"} found, ` : "", s = t.type === "tag" ? "" : t.type === "req" ? `, HTTP Method ${t.httpVerb}, Path ${t.path}` : `, ${t.description}`, r = `${$[t.type]} ${t.title} ${s}`;
      return `${e}Selected: ${r}`;
    }), T = (o) => {
      const t = o === "up" ? -1 : 1, e = c.value.length, s = (l.value + t + e) % e;
      l.value = s;
    };
    function z(o) {
      const t = new URL(window.location.href);
      return t.hash = o, t.toString();
    }
    function O() {
      const o = c.value;
      k(o[l.value]);
    }
    return (o, t) => (f(), B(n(Z), {
      state: o.modalState,
      variant: "search"
    }, {
      default: i(() => [
        a("div", {
          ref_key: "searchModalRef",
          ref: M,
          "aria-label": "Reference Search",
          class: "ref-search-container",
          role: "search"
        }, [
          g(n(ee), {
            modelValue: n(p),
            "onUpdate:modelValue": t[0] || (t[0] = (e) => j(p) ? p.value = e : null),
            "aria-controls": R,
            "aria-describedby": w,
            label: K.value,
            onInput: n(q),
            onKeydown: [
              t[1] || (t[1] = v(b((e) => T("down"), ["stop", "prevent"]), ["down"])),
              v(b(O, ["stop", "prevent"]), ["enter"]),
              t[2] || (t[2] = v(b((e) => T("up"), ["stop", "prevent"]), ["up"]))
            ]
          }, null, 8, ["modelValue", "label", "onInput", "onKeydown"])
        ], 512),
        g(n(te), {
          id: R,
          "aria-label": "Reference Search Results",
          class: "ref-search-results custom-scroll",
          noResults: !n(c).length
        }, {
          query: i(() => [
            d(u(n(p)), 1)
          ]),
          default: i(() => [
            (f(!0), N(x, null, G(n(c), (e, s) => (f(), B(n(oe), {
              id: I(e.item.href),
              key: e.refIndex,
              active: n(l) === s,
              href: z(e.item.href),
              icon: D[e.item.type],
              onClick: (r) => k(e),
              onFocus: (r) => l.value = s
            }, J({
              default: i(() => {
                var r, h, V, C;
                return [
                  a("span", {
                    class: Q({
                      deprecated: (h = (r = e.item.operation) == null ? void 0 : r.information) == null ? void 0 : h.deprecated
                    })
                  }, [
                    a("span", ie, [
                      d(u($[e.item.type]) + ":  ", 1),
                      (C = (V = e.item.operation) == null ? void 0 : V.information) != null && C.deprecated ? (f(), N(x, { key: 0 }, [
                        d(" (Deprecated)  ")
                      ], 64)) : X("", !0)
                    ]),
                    d(" " + u(e.item.title) + " ", 1),
                    t[3] || (t[3] = a("span", { class: "sr-only" }, ",", -1))
                  ], 2)
                ];
              }),
              _: 2
            }, [
              e.item.type !== "webhook" && (e.item.httpVerb || e.item.path) && e.item.path !== e.item.title ? {
                name: "description",
                fn: i(() => [
                  t[4] || (t[4] = a("span", { class: "sr-only" }, "Path: ", -1)),
                  d(" " + u(e.item.path), 1)
                ]),
                key: "0"
              } : e.item.description ? {
                name: "description",
                fn: i(() => [
                  t[5] || (t[5] = a("span", { class: "sr-only" }, "Description: ", -1)),
                  d(" " + u(e.item.description), 1)
                ]),
                key: "1"
              } : void 0,
              e.item.type === "req" ? {
                name: "addon",
                fn: i(() => [
                  g(ne, {
                    "aria-hidden": "true",
                    method: e.item.httpVerb ?? "get"
                  }, null, 8, ["method"]),
                  a("span", ce, " HTTP Method: " + u(e.item.httpVerb ?? "get") + ", ", 1)
                ]),
                key: "2"
              } : void 0
            ]), 1032, ["id", "active", "href", "icon", "onClick", "onFocus"]))), 128))
          ]),
          _: 1
        }, 8, ["noResults"]),
        a("div", {
          id: w,
          class: "ref-search-meta"
        }, t[6] || (t[6] = [
          a("span", {
            "aria-hidden": "true",
            class: "contents"
          }, [
            a("span", null, "↑↓ Navigate"),
            a("span", null, "⏎ Select")
          ], -1),
          a("span", { class: "sr-only" }, " Press up arrow / down arrow to navigate, enter to select, type to filter results ", -1)
        ]))
      ]),
      _: 1
    }, 8, ["state"]));
  }
});
export {
  ve as default
};
